=== debian/changelog ===
openms (1.9.0-4ubuntu1) saucy; urgency=low

  * Build depend on boost1.53.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Tue, 28 May 2013 11:05:21 +0100

openms (1.9.0-4) unstable; urgency=low

  * debian/rules: reinstate the .NOTPARALLEL: directive to preclude
    parallelization of the build, as the errors are too complicated to
    follow in the build log. Also inhibit the
    parallel=%,$(DEB_BUILD_OPTIONS) and NUMJOBS options processing, as 
    suggested by Aaron M. Ucko" <ucko@debian.org> (Closes: #702606).

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 29 Mar 2013 13:05:15 +0100

openms (1.9.0-3) unstable; urgency=low

  * debian/rules: fix problem with DEB_BUILD_GNU_TYPE not holding proper
    values on some platforms, like i386, by adding
    DEB_HOST_MULTIARCH. Thanks to "Aaron M. Ucko" <ucko@debian.org>
    (Closes: #702512);
  * Fix the watch file, thanks to Nick Black <nick.black@sprezzatech.com>
    (Closes: #702518);
   
  * New code in patch ensures that there is no creation of symlinks by
    CMake after building of the libraries, since the symlinks are created
    anyways in debian/.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 07 Mar 2013 18:38:56 +0100

openms (1.9.0-2) unstable; urgency=low

  * Transition from experimental to unstable. Tests were positive.
  
  * Fix non-inclusion of generated config include files in the
    /usr/include/OpenMS directory

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 Mar 2013 14:11:11 +0100

openms (1.9.0-1) experimental; urgency=low

  * 1.9.0 First Debian package release (Closes: #691129).

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 12 Nov 2012 15:58:12 +0100
